//AmpelServer.java                                  MM 2015
import java.net.*;                  // ServerSocket, Socket
import java.io.*;                            // IOException

/**
 * Server fuer Ampelschaltung,
 * erzeugt einen ServerSocket mit angegebenen Port,
 * wartet auf Client, erzeugt Socket fuer Kommunikation
 * und startet Protokoll fuer Client.
 * Aufruf: java AmpelServer <Port>
 */
class AmpelServer
{
  public static void main( String[] args)
  {
// Model
    AmpelModel model = new AmpelModel();

    try
    {
// Serversocket
      int port = Integer.parseInt( args[ 0]);
      ServerSocket server = new ServerSocket( port);
      System.out.println( "AmpelServer laeuft");

// Client-Verbindung
      while( true)
      {
        Socket s = server.accept();
        new AmpelServerProtokoll( s, model);
      }
    }
    catch( ArrayIndexOutOfBoundsException e)
    {
      System.out.println
      ( "\nAufruf: java AmpelServer <Port>\n");
    }
    catch( IOException e)
    {
      System.out.println
      ( "\nServer konnte nicht gestartet werden\n  " + e);
    }
  }
}